diff --git a/Makefile.am b/Makefile.am
index 19c9eb473..39f4403fe 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -24,7 +24,7 @@ BatteryMeter.c Process.c ProcessList.c RichString.c ScreenManager.c Settings.c \
 SignalsPanel.c StringUtils.c SwapMeter.c TasksMeter.c UptimeMeter.c \
 TraceScreen.c UsersTable.c Vector.c AvailableColumnsPanel.c AffinityPanel.c \
 HostnameMeter.c OpenFilesScreen.c Affinity.c IncSet.c Action.c EnvScreen.c \
-InfoScreen.c XAlloc.c
+InfoScreen.c XAlloc.c UnameMeter.c
 
 myhtopheaders = AvailableColumnsPanel.h AvailableMetersPanel.h \
 CategoriesPanel.h CheckItem.h ClockMeter.h ColorsPanel.h ColumnsPanel.h \
@@ -34,7 +34,7 @@ BatteryMeter.h Meter.h MetersPanel.h Object.h Panel.h ProcessList.h RichString.h
 ScreenManager.h Settings.h SignalsPanel.h StringUtils.h SwapMeter.h \
 TasksMeter.h UptimeMeter.h TraceScreen.h UsersTable.h Vector.h Process.h \
 AffinityPanel.h HostnameMeter.h OpenFilesScreen.h Affinity.h IncSet.h Action.h \
-EnvScreen.h InfoScreen.h XAlloc.h
+EnvScreen.h InfoScreen.h XAlloc.h UnameMeter.h
 
 if HTOP_LINUX
 htop_CFLAGS += -rdynamic 
diff --git a/UnameMeter.c b/UnameMeter.c
new file mode 100644
index 000000000..761c3edf1
--- /dev/null
+++ b/UnameMeter.c
@@ -0,0 +1,46 @@
+/*
+htop - UnameMeter.c
+(C) 2004-2011 Hisham H. Muhammad
+Released under the GNU GPL, see the COPYING file
+in the source distribution for its full text.
+*/
+
+#include "UnameMeter.h"
+
+#include "CRT.h"
+
+#include <sys/utsname.h>
+
+/*{
+#include "Meter.h"
+}*/
+
+int UnameMeter_attributes[] = {
+   HOSTNAME
+};
+
+static void UnameMeter_updateValues(Meter* this, char* buffer, int size) {
+   (void) this;
+   struct utsname *data = NULL;
+   data = xMalloc(sizeof(struct utsname));
+   uname(data);
+   snprintf(buffer, size, "%s %s %s", data->sysname, data->release,
+                                      data->machine);
+   free(data);
+}
+
+MeterClass UnameMeter_class = {
+   .super = {
+      .extends = Class(Meter),
+      .delete = Meter_delete
+   },
+   .updateValues = UnameMeter_updateValues,
+   .defaultMode = TEXT_METERMODE,
+   .maxItems = 0,
+   .total = 1.0,
+   .attributes = UnameMeter_attributes,
+   .name = "Uname",
+   .uiName = "uname",
+   .description = "uname: OS kernel name and release",
+   .caption = "uname: "
+};
diff --git a/UnameMeter.h b/UnameMeter.h
new file mode 100644
index 000000000..ab7ce461e
--- /dev/null
+++ b/UnameMeter.h
@@ -0,0 +1,18 @@
+/* Do not edit this file. It was automatically generated. */
+
+#ifndef HEADER_UnameMeter
+#define HEADER_UnameMeter
+/*
+htop - UnameMeter.h
+(C) 2004-2011 Hisham H. Muhammad
+Released under the GNU GPL, see the COPYING file
+in the source distribution for its full text.
+*/
+
+#include "Meter.h"
+
+extern int UnameMeter_attributes[];
+
+extern MeterClass UnameMeter_class;
+
+#endif
diff --git a/darwin/Platform.c b/darwin/Platform.c
index 9274d0d80..cf69def70 100644
--- a/darwin/Platform.c
+++ b/darwin/Platform.c
@@ -15,6 +15,7 @@ in the source distribution for its full text.
 #include "ClockMeter.h"
 #include "HostnameMeter.h"
 #include "UptimeMeter.h"
+#include "UnameMeter.h"
 #include "DarwinProcessList.h"
 
 #include <stdlib.h>
@@ -108,9 +109,10 @@ MeterClass* Platform_meterTypes[] = {
    &MemoryMeter_class,
    &SwapMeter_class,
    &TasksMeter_class,
+   &UptimeMeter_class,
    &BatteryMeter_class,
    &HostnameMeter_class,
-   &UptimeMeter_class,
+   &UnameMeter_class,
    &AllCPUsMeter_class,
    &AllCPUs2Meter_class,
    &LeftCPUsMeter_class,
diff --git a/freebsd/Platform.c b/freebsd/Platform.c
index 4185a8b5a..b21a35d93 100644
--- a/freebsd/Platform.c
+++ b/freebsd/Platform.c
@@ -15,6 +15,7 @@ in the source distribution for its full text.
 #include "UptimeMeter.h"
 #include "ClockMeter.h"
 #include "HostnameMeter.h"
+#include "UnameMeter.h"
 #include "FreeBSDProcess.h"
 #include "FreeBSDProcessList.h"
 
@@ -97,6 +98,7 @@ MeterClass* Platform_meterTypes[] = {
    &UptimeMeter_class,
    &BatteryMeter_class,
    &HostnameMeter_class,
+   &UnameMeter_class,
    &AllCPUsMeter_class,
    &AllCPUs2Meter_class,
    &LeftCPUsMeter_class,
diff --git a/linux/Platform.c b/linux/Platform.c
index 04360ca37..d5caf1efb 100644
--- a/linux/Platform.c
+++ b/linux/Platform.c
@@ -21,6 +21,7 @@ in the source distribution for its full text.
 #include "UptimeMeter.h"
 #include "ClockMeter.h"
 #include "HostnameMeter.h"
+#include "UnameMeter.h"
 #include "LinuxProcess.h"
 
 #include <math.h>
@@ -119,6 +120,7 @@ MeterClass* Platform_meterTypes[] = {
    &UptimeMeter_class,
    &BatteryMeter_class,
    &HostnameMeter_class,
+   &UnameMeter_class,
    &AllCPUsMeter_class,
    &AllCPUs2Meter_class,
    &LeftCPUsMeter_class,
diff --git a/openbsd/Platform.c b/openbsd/Platform.c
index 9273abc08..7b5d00101 100644
--- a/openbsd/Platform.c
+++ b/openbsd/Platform.c
@@ -16,6 +16,7 @@ in the source distribution for its full text.
 #include "UptimeMeter.h"
 #include "ClockMeter.h"
 #include "HostnameMeter.h"
+#include "UnameMeter.h"
 #include "SignalsPanel.h"
 #include "OpenBSDProcess.h"
 #include "OpenBSDProcessList.h"
@@ -153,6 +154,7 @@ MeterClass* Platform_meterTypes[] = {
    &UptimeMeter_class,
    &BatteryMeter_class,
    &HostnameMeter_class,
+   &UnameMeter_class,
    &AllCPUsMeter_class,
    &AllCPUs2Meter_class,
    &LeftCPUsMeter_class,
diff --git a/unsupported/Platform.c b/unsupported/Platform.c
index 04e8b4e77..cbd27c375 100644
--- a/unsupported/Platform.c
+++ b/unsupported/Platform.c
@@ -14,6 +14,7 @@ in the source distribution for its full text.
 #include "LoadAverageMeter.h"
 #include "ClockMeter.h"
 #include "HostnameMeter.h"
+#include "UnameMeter.h"
 #include "UptimeMeter.h"
 
 /*{
@@ -68,9 +69,10 @@ MeterClass* Platform_meterTypes[] = {
    &MemoryMeter_class,
    &SwapMeter_class,
    &TasksMeter_class,
+   &UptimeMeter_class,
    &BatteryMeter_class,
    &HostnameMeter_class,
-   &UptimeMeter_class,
+   &UnameMeter_class,
    &AllCPUsMeter_class,
    &AllCPUs2Meter_class,
    &LeftCPUsMeter_class,
